-- Include Encounter Files

-- Local Variables
local lastVoice = 0;
local firstCall = 0;

-- Helper Function to receive the remaining Time of a Debuff
local function getDebuffTime(tarUnit, abilityId)

  local result = 0;
  
  -- Loop through all Debuffs
  for i=1,40,1 do
    local _, _, _, _, _, _, expirationTime, _, _, _, spellId = UnitDebuff(tarUnit, i); 
    
    -- Error Check. Nil Values should be handled
    if expirationTime ~= nil and spellId ~= nil then
      -- Target has the specific Debuff
      if spellId == abilityId then
        result = expirationTime - GetTime();  
      end
    end
  end
  
  -- Handle negative Numbers
  if result >= 0 then
    return result;
  else
    return 0;
  end
end


-- Helper Function to determine whether the Target is targeting a specific Player
local function isTanking(playerID)
  local ttName = UnitName("targettarget");
  local pName  = UnitName(playerID);
  
  if ttName ~= nil and pName ~= nil and ttName == pName then
    return true;
  else
    return false;
  end
end


-- t hat weniger auf overwhelm und aggro -> taunt sound

-- Plays a Sound every time the Player needs to taunt
function ursocHandle()
  -- Initialize
  if firstCall == 0 then
    lastVoice = GetTime();
    firstCall = 1;
  end
  
  -- Check whether the Player is tanking
  local isTanking = isTanking("player");
  
  -- t1: Player, t2: Focus (Other Tank)
  -- Get Tank Debuffs
  local pOverwhelm = getDebuffTime("player", 197943);
  local pRendFlesh = getDebuffTime("player", 204859);
  
  local tOverwhelm = getDebuffTime("focus" , 197943);
  local tRendFlesh = getDebuffTime("focus" , 204859);
  
  -- Calculate maximal Debuff Time on each Tank
  local pMax = 0;
  local tMax = 0;
  
  if pOverwhelm > pRendFlesh then
    pMax = pOverwhelm;
  else
    pMax = pRendFlesh;
  end
  
  if tOverwhelm > tRendFlesh then
    tMax = tOverwhelm;
  else
    tMax = tRendFlesh;
  end
  
  -- Voice only once per second
  if GetTime() - lastVoice >= 1 then 
    -- If the remaining Debuff Time of the Player is less the remaining Debuff Time of the other Tank, the Player needs to taunt
    if pMax < tMax and not isTanking then
      PlaySoundFile("interface\\addons\\EbonBladeRaidAssist\\Resources\\taunt.mp3", "Master");
      lastVoice = GetTime();
    end
  end
  
end

-- Create Frame handling Events
local ebonBladeRaidAssistFrame = CreateFrame("Frame");
ebonBladeRaidAssistFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
ebonBladeRaidAssistFrame:SetScript("OnEvent",
  function(self, event, ...)  
    -- Check whether Player is in Raid
    local zoneName = GetRealZoneText();
  
    if zoneName == "The Emerald Nightmare" or zoneName == "Der Smaragdgrüne Alptraum" then    
      
      -- Select Encounter
      local tarName = UnitName("target");
      
      -- Ursoc
      if tarName == 'Ursoc' then
        ursocHandle();
      end
      
    end
  end
)